#!/bin/bash

source /remote/Xilinx/2015.4/SDK/2015.4/settings64.sh

echo "Building modular_quad_pid"

if [ ! -d ../.metadata ]; then
    # Haven't configured XSDK environment yet. Do that now

    ECLIPSE=/remote/Xilinx/2015.4/SDK/2015.4/eclipse/lnx64.o/eclipse
    VM=/remote/Xilinx/2015.4/SDK/2015.4/tps/lnx64/jre/bin
    WSPACE=$(dirname $0)/..
    HW=$WSPACE/system_hw_platform
    BSP=$WSPACE/system_bsp
    APP=$WSPACE/modular_quad_pid

    echo "Setting up dependencies for modular_quad_pid"

    # Import the system_hw_platform into the workspace
    $ECLIPSE -vm $VM -nosplash -application org.eclipse.cdt.managedbuilder.core.headlessbuild \
        -import $HW \
        -data $WSPACE \
        -vmargs -Dorg.eclipse.cdt.core.console=org.eclipse.cdt.core.systemConsole || exit 1

    # Create the BSP
    xsct .create_bsp.tcl || exit 1

    # Import the system_bsp and modular_quad_pid into workspace
    $ECLIPSE -vm $VM -nosplash -application org.eclipse.cdt.managedbuilder.core.headlessbuild \
        -import $BSP \
        -import $APP \
        -data $WSPACE \
        -vmargs -Dorg.eclipse.cdt.core.console=org.eclipse.cdt.core.systemConsole || exit 1

    # Build the BSP
    xsct .build_bsp.tcl || exit 1

fi

xsct .build_app.tcl || exit 1
